# Connection: root@localhost
# Host: localhost
# Saved: 2004-07-07 21:54:48
# 
# Host: localhost
# Database: vincitech
# Table: 'entreprise'
# 
CREATE TABLE `entreprise` (
  `id` int(11) NOT NULL auto_increment,
  `nom` varchar(30) NOT NULL default '',
  `secteur` varchar(100) NOT NULL default '',
  `rue` varchar(45) default NULL,
  `cp` int(10) default NULL,
  `ville` varchar(45) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=InnoDB; 

# Host: localhost
# Database: vincitech
# Table: 'personDetails'
# 
CREATE TABLE `personDetails` (
  `idPerson` int(11) NOT NULL default '0',
  `idEntreprise` int(10) default '0',
  `fonction` varchar(60) default '',
  `rue` varchar(45) default NULL,
  `cp` int(10) unsigned default NULL,
  `ville` varchar(45) default NULL,
  `tel1` varchar(12) default NULL,
  `tel2` varchar(12) default NULL,
  `datenaiss` date default NULL,
  `mail` varchar(60) default NULL,
  PRIMARY KEY  (`idPerson`),
  KEY `Employe_FKI1` (`idEntreprise`),
  CONSTRAINT `personDetails_ibfk_1` FOREIGN KEY (`idPerson`) REFERENCES `person` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `personDetails_ibfk_2` FOREIGN KEY (`idEntreprise`) REFERENCES `entreprise` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) TYPE=InnoDB; 

# Host: localhost
# Database: vincitech
# Table: 'stage'
# 
CREATE TABLE `stage` (
  `idApprenti` int(11) NOT NULL default '0',
  `idEntreprise` int(11) NOT NULL default '0',
  `debut` date NOT NULL default '0000-00-00',
  `idTuteur` int(11) NOT NULL default '0',
  `idProf` int(11) NOT NULL default '0',
  `fin` date NOT NULL default '0000-00-00',
  `intitule` text,
  PRIMARY KEY  (`idApprenti`,`idEntreprise`,`debut`),
  KEY `idEntreprise` (`idEntreprise`),
  KEY `idTuteur` (`idTuteur`),
  KEY `idProf` (`idProf`),
  CONSTRAINT `stage_ibfk_1` FOREIGN KEY (`idEntreprise`) REFERENCES `entreprise` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `stage_ibfk_2` FOREIGN KEY (`idTuteur`) REFERENCES `person` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `stage_ibfk_3` FOREIGN KEY (`idProf`) REFERENCES `person` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `stage_ibfk_4` FOREIGN KEY (`idApprenti`) REFERENCES `person` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) TYPE=InnoDB; 

# Host: localhost
# Database: vincitech
# Table: 'taxe'
# 
CREATE TABLE `taxe` (
  `idEntreprise` int(11) NOT NULL default '0',
  `annee` int(10) unsigned NOT NULL default '0',
  `montant` float NOT NULL default '0',
  `nature` varchar(45) NOT NULL default '',
  PRIMARY KEY  (`idEntreprise`,`annee`),
  KEY `Taxe_FKIndex1` (`idEntreprise`),
  CONSTRAINT `FOREIGN` FOREIGN KEY (`idEntreprise`) REFERENCES `entreprise` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) TYPE=InnoDB; 

